<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

    <script>
        /* 
            Faça um algoritmo que retorne a letra mais repetida de uma string
        */
        function mostUsedChar(text) {
            const charMap = {};
            let max = 0;
            let charMax = '';

            for (let character of text) {
                if (charMap[character] === undefined) {
                    charMap[character] = 1;
                } else {
                    charMap[character] = charMap[character] + 1;
                    if (charMap[character] > max) {
                        max = charMap[character];
                        charMax = character;
                    }
                }
            }

            return charMax;
        }

        // Resultados esperados
        console.log(mostUsedChar("fdgdfgff"), 'f') // f
        console.log(mostUsedChar("Lorem ipsum"), 'm') // m
        console.log(mostUsedChar("adsassdasd"), 's') // s
        console.log(mostUsedChar("testeeeee"), 'e') // e

    </script>
</body>

</html>